/*
    Se van a crear todas las clases de botones para el proyecto.
    Unicamente se van a compilar dentro del main.css.
*/



/*------------------------------------*\
    #Buttons
\*------------------------------------*/

// Tiempo de las lineas del boton animado
$time: 1000ms;
// Tiempo de retardo para comenzar la segunda linea
$time-delay: $time / 2;
// Ancho de la línea animada del botón - motion
$line: 3px;
// Color de las lineas
$light: var(--brand-primary);
$dark: var(--brand-secondary);

.btn {
    position: relative;
    display: inline-flex;
    justify-content: center;
    align-items: center;
    height: var(--box-7);
    padding-left: var(--box-3);
    padding-right: var(--box-3);
    cursor: pointer;
    color: var(--white);
    font-size: var(--txt-4);
    background: linear-gradient(to left, #078cb1, #af2fb9);
    border-radius: var(--edge-sm);
    border: 1px solid transparent;
    transition: 250ms ease-in;
    transition-property: background, color, transform, box-shadow, border-color;

    &:hover,
    &:focus,
    &:active {
        background: linear-gradient(to left, #087b9b, #9e2aa7);
        box-shadow: 2px 2px 10px var(--gray-darker);
    }





    /*------------------------------------*\
        #Composición de botones
    \*------------------------------------*/

    // Anchos de botones
    &--large {
        width: 100%;

        @media #{$mq-md} {width: var(--box-48);}
    }


    // Boton animado -- lineas de seguimiento
    &--azul-motion {
        overflow: hidden;
        border-radius: 0;
        border: 0;
        background: #0a4779;
    }

    // lineas animadas del boton
    &__line-decoration {
        position: absolute;

        // Linea Superior
        &:nth-child(1) {
            top: 0;
            left: 0;
            width: 100%;
            height: $line;
            background: linear-gradient(to left, $light, $dark);
            animation: motionTop $time linear infinite;
        }
        @keyframes motionTop {
            0% {transform: translateX(-100%);}
            100% {transform: translateX(100%);}
        }

        // Linea Derecha
        &:nth-child(2) {
            top: 0;
            right: 0;
            width: $line;
            height: 100%;
            background: linear-gradient(to top, $light, $dark);
            animation: motionRight $time linear infinite;
            animation-delay: $time-delay;
        }
        @keyframes motionRight {
            0% {transform: translateY(-100%);}
            100% {transform: translateY(100%);}
        }

        // Linea Inferior
        &:nth-child(3) {
            bottom: 0;
            left: 0;
            width: 100%;
            height: $line;
            background: linear-gradient(to right, $light, $dark);
            animation: motionBottom $time linear infinite;
        }
        @keyframes motionBottom {
            0% {transform: translateX(100%);}
            100% {transform: translateX(-100%);}
        }

        // Linea Izquierda
        &:nth-child(4) {
            top: 0;
            left: 0;
            width: $line;
            height: 100%;
            background: linear-gradient(to bottom, $light, $dark);
            animation: motionLeft $time linear infinite;
            animation-delay: $time-delay;
        }
        @keyframes motionLeft {
            0% {transform: translateY(100%);}
            100% {transform: translateY(-100%);}
        }
    }
}
